#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)
from __future__ import with_statement

#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2010  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import os, sys, tarfile, scriptlib

copy_path = ' '.join(sys.argv[1:] ) if sys.argv[1:] else None

_module_path = os.path.split(os.path.realpath(sys._getframe().f_code.co_filename))[0]

# on choisit comme rpertoire courant le repertoire de wxgeometrie (pour Linux)
os.chdir(os.path.normpath('%s/..' %_module_path))

sys.path.append(os.getcwd())

from param import version
version = version.replace(' ', '_')

execfile(os.path.normpath("tools/list_distrib_files.py"))

from distrib_files import paths

# on choisit comme rpertoire courant le repertoire de wxgeometrie (pour Linux)
os.chdir(os.path.normpath('%s/../..' %_module_path))

print(u'Cration du paquet...')
try:
    nom_archive = 'wxgeometrie_%s.tar.gz' %version
    f = tarfile.open(nom_archive, 'w:gz')
    for filename in paths:
        include = paths[filename]
        assert isinstance(include, bool)
        if include:
            f.add('wxgeometrie' + filename[1:])
    # 'personnaliser.py' est gnr  partir de 'personnaliser_.py'
    # Ceci vite de copier mes paramtres personnels.
    f.add(name = os.path.normpath('wxgeometrie/param/personnaliser_.py'),
          arcname = os.path.normpath('wxgeometrie/param/personnaliser.py'))
finally:
    f.close()
print(u'Paquet cr.')

if copy_path is not None:
    print('Copie du paquet...')
    scriptlib.cp(nom_archive, copy_path)
    print(u'Paquet copi.')