#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)
from __future__ import with_statement

#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2010  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


if __name__ == '__main__':
    # on choisit comme répertoire courant le repertoire de wxgeometrie (pour Linux)
    path = os.path.split(__file__)[0]
    if path:
        os.chdir(path)
        os.chdir('..')


from geolib import *
import geolib
objets=[obj for obj in geolib.__dict__.values() if isinstance(obj, type) and issubclass(obj, geolib.Objet) and not (obj.__name__.endswith("_generique") or obj.__name__ in ("Objet", "Ligne"))]
objets.sort(key=lambda x:getattr(x,"__name__"))
t = time.localtime()
t = "%s_%s_%s" %(t[2], t[1], t[0])
try:
    f = open("geolib" + os.sep + "liste_des_objets_%s.txt" %t, "w")
    f.write(str2("Liste des objets au " + t.replace("_", "/") + "\n___________________________\n\n\n"))
    f.write(str2("Total: %s objets (hors objets generiques)\n\n\n" % len(objets)))
    for obj in objets:
        f.write(str2(obj.__name__ + "\n-----------------\n"))
        f.write(str2(obj.__doc__ + "\n\n\n"))
finally:
    f.close()
